=== modified file 'drizzled/item/cmpfunc.cc'
--- drizzled/item/cmpfunc.cc	2011-01-24 22:22:11 +0000
+++ drizzled/item/cmpfunc.cc	2011-01-28 21:33:48 +0000
@@ -5114,15 +5114,15 @@
     return 0;
   List_iterator_fast<Item_field> it(fields);
   Item *item= const_item ? const_item : it++;
+  eval_item->store_value(item);
   if ((null_value= item->null_value))
     return 0;
-  eval_item->store_value(item);
   while ((item_field= it++))
   {
     /* Skip fields of non-const tables. They haven't been read yet */
     if (item_field->field->getTable()->const_table)
     {
-      if ((null_value= item_field->null_value) || eval_item->cmp(item_field))
+      if (eval_item->cmp(item_field) || (null_value= item_field->null_value))
         return 0;
     }
   }

=== modified file 'tests/include.am'
--- tests/include.am	2011-01-26 21:35:28 +0000
+++ tests/include.am	2011-01-29 14:17:35 +0000
@@ -48,6 +48,15 @@
 	      --testdir=../${top_srcdir}/tests \
 	      --dtr-build-thread=$$$$
 
+TEST_RUN_DBQP= $(PYTHON) ../$(top_srcdir)/tests/dbqp.py \
+		--top-srcdir=../${top_srcdir} \
+		--top-builddir=../${top_builddir} \
+		--reorder \
+		--basedir=../${top_srcdir} \
+		--testdir=../${top_srcdir}/tests \
+                --workdir=../${top_srcdir}/tests/dbqp_work
+
+
 EXTRA_DIST += \
 	$(EXTRA_SCRIPTS) \
 	${srcdir}/tests/README.stress \
@@ -92,6 +101,7 @@
 	test-all \
 	test-big \
 	test-drizzle \
+        test-dbqp \
 	test-plugins
 
 # Target 'test' will run the regression test suite using the built server.
@@ -137,9 +147,15 @@
 test-plugins:
 	( cd tests && $(TEST_RUN) $(TEST_RUN_EXTRA_OPTIONS) --fast --force --suite=$(PLUGIN_TESTS) )
 
+test-dbqp:
+	( cd tests && $(TEST_RUN_DBQP) $(TEST_RUN_EXTRA_OPTIONS) --fast --force --suite=$(NORMAL_TESTS) )
+
+
 distclean-local: nukevar
 
 nukevar:
-	rm -rf tests/var
+	rm -rf tests/var \
+        rm -rf tests/dbqp_work 
+ 
 
 .PHONY: nukevar

=== modified file 'tests/lib/drizzle_test_run/dtr_test_management.py'
--- tests/lib/drizzle_test_run/dtr_test_management.py	2011-01-27 23:24:42 +0000
+++ tests/lib/drizzle_test_run/dtr_test_management.py	2011-01-28 20:45:12 +0000
@@ -171,7 +171,7 @@
                                  resultdir, disabled_tests)  
         test_case = testCase(self.system_manager, test_case, test_name, suite_name, 
                              suite_dir, test_server_options,test_path, result_path,
-                             debug=self.debug)      
+                             master_sh=master_sh, debug=self.debug)      
         return test_case
 
 
@@ -198,7 +198,11 @@
         result_file_name = test_name+'.result'       
         result_path = self.find_result_path(resultdir, result_file_name)
         comment = None
-        master_sh = None
+        master_sh_path = test_path.replace('.test','-master.sh')
+        if os.path.exists(master_sh_path):
+            master_sh = master_sh_path 
+        else:
+            master_sh = None
         master_opt_path = test_path.replace('.test','-master.opt')
         test_server_options = test_server_options + self.process_opt_file(
                                                            master_opt_path)
@@ -425,8 +429,6 @@
                 organizer[key].append(testcase)
             else:
                 organizer[key] = [testcase]
-        for key in organizer.keys():
-            print key, len(organizer[key])
         for value_list in organizer.values():
             ordered_list = ordered_list + value_list
         self.test_list = ordered_list

=== modified file 'tests/lib/sys_mgmt/codeTree.py'
--- tests/lib/sys_mgmt/codeTree.py	2011-01-27 20:13:55 +0000
+++ tests/lib/sys_mgmt/codeTree.py	2011-01-29 13:59:52 +0000
@@ -58,10 +58,10 @@
         self.skip_keys = ['ld_lib_paths']
         self.debug = variables['debug']
         self.verbose = variables['verbose']
-        self.basedir = self.system_manager.find_path([variables['basedir']])
+        self.basedir = self.system_manager.find_path([os.path.abspath(variables['basedir'])])
         self.source_dist = os.path.isdir(os.path.join(self.basedir, 'drizzled'))
-        self.builddir = self.system_manager.find_path([self.basedir])
-        self.testdir = self.system_manager.find_path([variables['testdir']])
+        self.builddir = self.system_manager.find_path([os.path.abspath(self.basedir)])
+        self.testdir = self.system_manager.find_path([os.path.abspath(variables['testdir'])])
         self.clientbindir = self.system_manager.find_path([os.path.join(self.builddir, 'client')
                                      , os.path.join(self.basedir, 'client')
                                      , os.path.join(self.basedir, 'bin')])

=== modified file 'tests/lib/sys_mgmt/system_management.py'
--- tests/lib/sys_mgmt/system_management.py	2011-01-28 02:31:42 +0000
+++ tests/lib/sys_mgmt/system_management.py	2011-01-29 13:59:52 +0000
@@ -34,6 +34,7 @@
 import os
 import sys
 import shutil
+import getpass
 import commands
 
 from lib.sys_mgmt.port_management import portManager
@@ -64,8 +65,11 @@
         self.no_shm = variables['noshm']
         self.shm_path = self.find_path(["/dev/shm", "/tmp"], required=0)
         self.cur_os = os.uname()[0]
-        self.symlink_name = 'dtr_work_sym'
-        self.workdir = variables['workdir']
+        self.cur_user = getpass.getuser()
+        self.symlink_name = 'dbqp_workdir_%s' %(self.cur_user)
+        self.workdir = os.path.abspath(variables['workdir'])
+        self.top_srcdir = os.path.abspath(variables['topsrcdir'])
+        self.top_builddir = os.path.abspath(variables['topbuilddir'])
         self.start_dirty = variables['startdirty']
         self.valgrind = variables['valgrind']
         self.gdb = variables['gdb']
@@ -91,8 +95,8 @@
                                 , 'LC_CTYPE' : ('C',0,0)
                                 , 'LC_COLLATE' : ('C',0,0)
                                 , 'USE_RUNNING_SERVER' : ("0",0,0)
-                                , 'TOP_SRCDIR' : (self.code_tree.srcdir,0,0)
-                                , 'TOP_BUILDDIR' : (self.code_tree.builddir,0,0)
+                                , 'TOP_SRCDIR' : (self.top_srcdir,0,0)
+                                , 'TOP_BUILDDIR' : (self.top_builddir,0,0)
                                 , 'DRIZZLE_TEST_DIR' : (self.code_tree.testdir,0,0)
                                 , 'DTR_BUILD_THREAD' : ("-69.5",0,0)
                                 , 'LD_LIBRARY_PATH' : (self.ld_lib_paths,1,1)

=== modified file 'tests/lib/test_mgmt/test_execution.py'
--- tests/lib/test_mgmt/test_execution.py	2011-01-27 20:13:55 +0000
+++ tests/lib/test_mgmt/test_execution.py	2011-01-28 20:45:12 +0000
@@ -121,6 +121,7 @@
             self.logging.verbose("Executor: %s beginning test execution..." %(self.name))
         while self.test_manager.has_tests() and keep_running == 1:
             self.get_testCase()
+            self.handle_system_reqs()
             bad_start = self.handle_server_reqs()
             if bad_start:
                 # Our servers didn't start, we mark it a failure
@@ -153,7 +154,11 @@
                 server.failed_test = 1
 
    
-
-    
-  
-
+    def handle_system_reqs(self):
+        """ We check our test case and see what we need to do
+            system-wise to get ready
+
+        """
+
+        if self.current_testcase.master_sh:
+                self.system_manager.execute_cmd("/bin/sh %s" %(self.current_testcase.master_sh))

=== modified file 'tests/lib/test_mode.py'
--- tests/lib/test_mode.py	2011-01-27 23:24:42 +0000
+++ tests/lib/test_mode.py	2011-01-28 20:03:10 +0000
@@ -2,6 +2,8 @@
 # -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
 # vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
 #
+# Copyright (C) 2010 Patrick Crews
+#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or

=== modified file 'tests/lib/test_run_options.py'
--- tests/lib/test_run_options.py	2011-01-28 02:31:42 +0000
+++ tests/lib/test_run_options.py	2011-01-29 14:04:49 +0000
@@ -31,10 +31,15 @@
 def comma_list_split(option, opt, value, parser):
     """Callback for splitting input expected in list form"""
     cur_list = getattr(parser.values, option.dest,[])
+    input_list = value.split(',')
+    # this is a hack to work with make target - we
+    # don't deal with a dangling ',' in our list
+    if '' in input_list:
+        input_list.remove('')
     if cur_list:
-        value_list = cur_list + value.split(',')
+        value_list = cur_list + input_list 
     else:
-        value_list = value.split(',')
+        value_list = input_list 
     setattr(parser.values, option.dest, value_list)
 
 def organize_options(args, test_cases):
@@ -134,7 +139,7 @@
   , type='string'
   , action="callback"
   , callback=comma_list_split
-  , help="The name of the suite containing tests we want. Use one --suite arg for each suite you want to use. [default=autosearch]"
+  , help="The name of the suite containing tests we want. Can accept comma-separated list (with no spaces).  Additional --suite args are appended to existing list [autosearch]"
   )
 
 test_control_group.add_option(
@@ -204,6 +209,7 @@
   , help = "Path to the directory containing client program binaries for use in testing [%default]"
   )
 
+
 test_subject_control_group.add_option(
     "--engine"
    , dest="engine"
@@ -217,7 +223,7 @@
 
 
 # environment options
-# define where to find our drizzled, client dirs, working dirs, etc
+# define where to find our testsets, working dirs, etc
 environment_control_group = optparse.OptionGroup(parser, 
                             "Options for defining the testing environment")
 
@@ -238,6 +244,22 @@
   )
 
 environment_control_group.add_option(
+    "--top-srcdir"
+  , dest="topsrcdir"
+  , type='string'
+  , default = basedir_default
+  , help = "build option [%default]"
+  )
+
+environment_control_group.add_option(
+    "--top-builddir"
+  , dest="topbuilddir"
+  , type='string'
+  , default = basedir_default
+  , help = "build option [%default]"
+  )
+
+environment_control_group.add_option(
     "--no-shm"
   , dest="noshm"
   , action='store_true'

=== added file 'tests/suite/regression/r/709493.result'
--- tests/suite/regression/r/709493.result	1970-01-01 00:00:00 +0000
+++ tests/suite/regression/r/709493.result	2011-01-29 17:03:06 +0000
@@ -0,0 +1,11 @@
+create table t1 (pk int primary key, col_int int, col_int_unique int unique key);
+insert into t1 values (1,NULL,2), (2,0,0);
+create table t2 (pk int primary key, col_int int, col_int_unique int unique key);
+insert into t2 values (1,0,1), (2,0,2);
+select * from t1 left join t2
+on t1.col_int_unique = t2.col_int_unique and t1.col_int = t2.col_int 
+where t1.pk=1;
+pk	col_int	col_int_unique	pk	col_int	col_int_unique
+1	NULL	2	NULL	NULL	NULL
+drop table t1;
+drop table t2;

=== added file 'tests/suite/regression/t/709493.test'
--- tests/suite/regression/t/709493.test	1970-01-01 00:00:00 +0000
+++ tests/suite/regression/t/709493.test	2011-01-29 17:03:06 +0000
@@ -0,0 +1,11 @@
+create table t1 (pk int primary key, col_int int, col_int_unique int unique key);
+insert into t1 values (1,NULL,2), (2,0,0);
+create table t2 (pk int primary key, col_int int, col_int_unique int unique key);
+insert into t2 values (1,0,1), (2,0,2);
+
+select * from t1 left join t2
+  on t1.col_int_unique = t2.col_int_unique and t1.col_int = t2.col_int 
+  where t1.pk=1;
+
+drop table t1;
+drop table t2;

